ELBuildMenu = {};
ELBuildMenu.planks = 0;
ELBuildMenu.nails = 0;
ELBuildMenu.hinge = 0;
ELBuildMenu.doorknob = 0;
ELBuildMenu.cheat = false;
ELBuildMenu.woodWorkXp = 0;


ELBuildMenu.doBuildMenu = function(player, context, worldobjects, test)
	if test and ISWorldObjectContextMenu.Test then return true end

    if getCore():getGameMode()=="LastStand" then
        return;
    end

	ELBuildMenu.woodWorkXp = getSpecificPlayer(player):getPerkLevel(Perks.Woodwork);
	local thump = nil;

	local square = nil;

	-- we get the thumpable item (like wall/door/furniture etc.) if it exists on the tile we right clicked
	for i,v in ipairs(worldobjects) do
		square = v:getSquare();
		if instanceof(v, "IsoThumpable") and not v:isDoor() then
			thump = v;
		end
    end

	-- build menu
	-- if we have any thing to build in our inventory
	
	if ELBuildMenu.haveSomethingtoBuild(player) then
        if test then return ISWorldObjectContextMenu.setTest() end
		
		--local buildOption = context:addOption(getText("ContextMenu_Build"), worldobjects, nil);
		local subMenu = nil;
		local buildOption = nil;
		for i,v in ipairs(context.options) do
			if v.name == getText("ContextMenu_Build") then
				buildOption = v;
				subMenu = context:getSubMenu(buildOption.subOption);
			end
		end
		
		--if buildOption == nil then
		--	buildOption = context:addOption(getText("ContextMenu_Build"), worldobjects, nil);
		--end
		
		-- create a brand new context menu which contain our different material (wood, stone etc.) to build
		--local subMenu = ISContextMenu:getNew(context);
		
		-- We create the different option for this new menu (wood, stone etc.)
		-- check if we can build something in wood material
		if doELHaveSomethingtoBuildWood(player) then
			-- we add the subMenu to our current option (Build)
			--context:addSubMenu(buildOption, subMenu);
			
			ELBuildMenu.buildLightMenu(subMenu, player);
		end
	end
end

function ELBuildMenu.haveSomethingtoBuild(player)
--~ 	return true;
	return doELHaveSomethingtoBuildWood(player);
end

function doELHaveSomethingtoBuildWood(player)
	ELBuildMenu.materialOnGround = buildUtil.checkMaterialOnGround(getSpecificPlayer(player):getCurrentSquare())
	
	ELBuildMenu.planks = 0;
	ELBuildMenu.nails = 0;
	ELBuildMenu.hinge = 0;
	ELBuildMenu.doorknob = 0;
	
	ELBuildMenu.hasHammer = getSpecificPlayer(player):getInventory():contains("Hammer") or getSpecificPlayer(player):getInventory():contains("HammerStone")
	
	if ELBuildMenu.hasHammer then
	
	else
		return false;
	end
	ELBuildMenu.planks = ELBuildMenu.countMaterial(player, "Base.Plank")
	ELBuildMenu.nails = ELBuildMenu.countMaterial(player, "Base.Nails")
	ELBuildMenu.hinge = ELBuildMenu.countMaterial(player, "Base.Hinge")
	ELBuildMenu.doorknob = ELBuildMenu.countMaterial(player, "Base.Doorknob")
	return true;
end

-- **********************************************
-- **          *LIGHT SOURCES*                 **
-- **********************************************
ELBuildMenu.buildLightMenu = function(subMenu, player)
    local sprite = ELBuildMenu.getPillarLampSprite(player);
    local lampOption = subMenu:addOption("Electric Lamp on Pillar", worldobjects, ELBuildMenu.onPillarLamp, square, sprite, player);
    local toolTip = ELBuildMenu.canBuild(2,4,0,0,0,5,lampOption, player);
	--local toolTip = ELBuildMenu.canBuild(0,1,0,0,0,1,lampOption, player);
    if not getSpecificPlayer(player):getInventory():contains("LightBulb") and not ELBuildMenu.cheat then
        toolTip.description = toolTip.description .. " <RGB:1,0,0>" .. getItemText("Lightbulb") .. " 0/1 ";
        lampOption.onSelect = nil;
        lampOption.notAvailable = true;
    else
        toolTip.description = toolTip.description .. " <RGB:1,1,1>" .. getItemText("Lightbulb") .. " 1 ";
    end
	
    if not getSpecificPlayer(player):getInventory():contains("Rope") and not ELBuildMenu.cheat then
        toolTip.description = toolTip.description .. " <LINE> <RGB:1,0,0>" .. getItemText("Rope") .." 0/1 ";
        lampOption.onSelect = nil;
        lampOption.notAvailable = true;
    else
        toolTip.description = toolTip.description .. " <LINE> <RGB:1,1,1>" .. getItemText("Rope") .. "Rope 1 ";
    end
    toolTip:setName("Electric Lamp on Pillar");
    toolTip.description = "Electric Lamp on Pillar" .. " " .. toolTip.description;
    toolTip:setTexture("carpentry_02_59");
	ELBuildMenu.requireHammer(lampOption)

--    if lampOption.notAvailable then
--        option.notAvailable = true;
--    end
end

ELBuildMenu.onPillarLamp = function(worldobjects, square, sprite, player)
-- sprite, northSprite
    local lamp = ELElectricLightSource:new(sprite.sprite, sprite.northSprite, getSpecificPlayer(player));
    lamp.offsetX = 5;
    lamp.offsetY = 5;
    lamp.modData["need:Base.Plank"] = "2";
    lamp.modData["need:Base.Rope"] = "1";
    lamp.modData["need:Base.Nails"] = "4";
	lamp.modData["need:Base.Nails"] = "1";
    --lamp.modData["need:Base.Torch"] = "1";
    lamp:setEastSprite(sprite.eastSprite);
    lamp:setSouthSprite(sprite.southSprite);
    --lamp.fuel = "Base.Battery";
    lamp.baseItem = "Base.LightBulb";
    lamp.radius = 10;
    lamp.player = player
    getCell():setDrag(lamp, player);
end




-- ------------------------------------------------------------------------------

ELBuildMenu.getPillarLampSprite = function(player)
    local sprite = {};
    sprite.sprite = "carpentry_02_61";
    sprite.northSprite = "carpentry_02_60";
    sprite.southSprite = "carpentry_02_59";
    sprite.eastSprite = "carpentry_02_62";
    return sprite;
end

-- -------------------------------------------------------------------------------

ELBuildMenu.canBuild = function(plankNb, nailsNb, hingeNb, doorknobNb, baredWireNb, carpentrySkill, option, player)
	-- create a new tooltip
	local tooltip = ISBuildMenu.addToolTip();
	-- add it to our current option
	option.toolTip = tooltip;
	local result = true;
	if ELBuildMenu.cheat then
		return tooltip;
	end
	tooltip.description = "<LINE> <LINE>" .. getText("Tooltip_craft_Needs") .. " : <LINE>";
	-- now we gonna test all the needed material, if we don't have it, they'll be in red into our toolip
	if ELBuildMenu.planks < plankNb then
		tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. getItemText("Plank") .. " " .. ELBuildMenu.planks .. "/" .. plankNb .. " <LINE>";
		result = false;
	elseif plankNb > 0 then
		tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. getItemText("Plank") .. " " .. plankNb .. " <LINE>";
	end
	if ELBuildMenu.nails < nailsNb then
		tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. getItemText("Nails") .. " " .. ELBuildMenu.nails .. "/" .. nailsNb .. " <LINE>";
		result = false;
	elseif nailsNb > 0 then
		tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. getItemText("Nails") .. " " .. nailsNb .. " <LINE>";
	end
	if ELBuildMenu.doorknob < doorknobNb then
		tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. getItemText("Doorknob") .. " " .. ELBuildMenu.doorknob .. "/" .. doorknobNb .. " <LINE>";
		result = false;
	elseif doorknobNb > 0 then
		tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. getItemText("Doorknob") .. " " .. doorknobNb .. " <LINE>";
	end
	if ELBuildMenu.hinge < hingeNb then
		tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. getItemText("Door Hinge") .. " " .. ELBuildMenu.hinge .. "/" .. hingeNb .. " <LINE>";
		result = false;
	elseif hingeNb > 0 then
		tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. getItemText("Door Hinge") .. " " .. hingeNb .. " <LINE>";
	end
	if getSpecificPlayer(player):getPerkLevel(Perks.Woodwork) < carpentrySkill then
		tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. getText("IGUI_perks_Carpentry") .. " " .. getSpecificPlayer(player):getPerkLevel(Perks.Woodwork) .. "/" .. carpentrySkill .. " <LINE>";
		result = false;
	elseif carpentrySkill > 0 then
		tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. getText("IGUI_perks_Carpentry") .. " " .. carpentrySkill .. " <LINE>";
	end
	if not result then
		option.onSelect = nil;
		option.notAvailable = true;
	end
	return tooltip;
end


ELBuildMenu.addToolTip = function()
	local toolTip = ISToolTip:new();
	toolTip:initialise();
	toolTip:setVisible(false);
	return toolTip;
end

ELBuildMenu.countMaterial = function(player, fullType)
    local inv = getSpecificPlayer(player):getInventory()
    local count = inv:getItemCount(fullType)
    local type = string.split(fullType, "\\.")[2]
    for k,v in pairs(ELBuildMenu.materialOnGround) do
        if k == type then count = count + v end
    end
    return count
end

ELBuildMenu.requireHammer = function(option)
	if not ELBuildMenu.hasHammer and not ELBuildMenu.cheat then
		option.notAvailable = true
		option.onSelect = nil
	end
end

Events.OnFillWorldObjectContextMenu.Add(ELBuildMenu.doBuildMenu);