ELElectricLightSource = ISBuildingObject:derive("ELElectricLightSource");

function ELElectricLightSource:create(x, y, z, north, sprite)
	local cell = getWorld():getCell();
	self.sq = cell:getGridSquare(x, y, z);
	self.javaObject = IsoThumpable.new(cell, self.sq, sprite, north, self);
	buildUtil.setInfo(self.javaObject, self);

    -- light stuff
    local offsetX = 0;
    local offsetY = 0;
    if self.east then
        offsetX = self.offsetX;
    elseif self.west then
        offsetX = -self.offsetX;
    elseif self.south then
        offsetY = self.offsetY;
    elseif self.north then
        offsetY = -self.offsetY;
    end
	
	--local lightB = self.character:getInventory():AddItem("Base.Torch");
	
	local lightB = self.character:getInventory():AddItem("Base.LightBulb");
	lightB:setCanBeActivated(true);
	lightB:setLightDistance(20);
	lightB:setLightStrength(0.8);
	lightB:setName("TestTorch");
	lightB:setTorchCone(false);
	lightB:setDisappearOnUse(false);
	lightB:setType("Drainable");
	self.javaObject:createLightSource(10, offsetX, offsetY, 0, 0, "EL.ELNothing", lightB, self.character);
    --self.javaObject:createLightSource(self.radius, offsetX, offsetY, 0, 0, self.fuel, self.character:getInventory():FindAndReturn(self.baseItem), self.character);
	self.javaObject:setHaveFuel(false);
	if not (self.sq:haveElectricity() or (SandboxVars.ElecShutModifier > -1 and GameTime:getInstance():getNightsSurvived() < SandboxVars.ElecShutModifier) ) then
		self.javaObject:toggleLightSource(false);
	end

	self.character:getInventory():Remove(lightB);
	self.javaObject:getModData()["need:"..self.baseItem] = "1"
	
	buildUtil.consumeMaterial(self);
	
	-- the wooden wall have 100 base health + 100 per carpentry lvl
	self.javaObject:setMaxHealth(self:getHealth());
	-- the sound that will be played when our door frame will be broken
	self.javaObject:setBreakSound("breakdoor");
	-- add the item to the ground
    self.sq:AddSpecialObject(self.javaObject);
	
	
	buildUtil.addWoodXp(self);
	
	self.javaObject:transmitCompleteItemToServer()
end

function ELElectricLightSource:new(sprite, northSprite, player)
	local o = {};
	setmetatable(o, self);
	self.__index = self;
	o:init();
	o:setSprite(sprite);
	o:setNorthSprite(northSprite);
	o.canBarricade = false;
	o.dismantable = true;
    o.character = player;
    o.name = "Electronic Lamp Pillar";
	return o;
end

-- return the health of the new container, it's 100 + 100 per carpentry lvl
function ELElectricLightSource:getHealth()
	return 100 + buildUtil.getWoodHealth(self);
end

function ELElectricLightSource:isValid(square)
	if not self:haveMaterial(square) then return false end
	return square:isFree(true)
--	return ISBuildingObject.isValid(self, square, north);
end

function ELElectricLightSource:render(x, y, z, square)
	ISBuildingObject.render(self, x, y, z, square)
end

