ELClientCommands = {}
local ELCommands = {}
ELClientCommands.Lightpoles = {}
ELCommands.object = {}

ELClientCommands.wantNoise = getDebug()
local noise = function(msg)
	if (ELClientCommands.wantNoise) then print('ClientCommand: '..msg) end
end


local getThumpableElectricLight = function(x, y, z)
	local gs = getCell():getGridSquare(x, y, z)
	if not gs then return nil end
	for i=0,gs:getSpecialObjects():size()-1 do
		local o = gs:getSpecialObjects():get(i)
		if o and instanceof(o, 'IsoThumpable') then
			if not o:haveFuel() then
				if o:getName() == "Lamp on Pillar" or o:getName() == "Electronic Lamp Pillar" or o:getName() == "Light Pole" then
					return o;
				end
			end
		end
	end
	return nil
end

ELCommands.object.toggleElectricLight = function(player, args)
	local o = getThumpableElectricLight(args.x, args.y, args.z)
	if o then
		if o:getSquare():haveElectricity() or (SandboxVars.ElecShutModifier > -1 and GameTime:getInstance():getNightsSurvived() < SandboxVars.ElecShutModifier) then
			o:toggleLightSource(not o:isLightSourceOn())
			o:sendObjectChange('lightSource')
		else
			o:toggleLightSource(false)
			o:sendObjectChange('lightSource')
		end
		if o:isLightSourceOn() then
			
			ELClientCommands.addPole(o:getSquare());
		else
			ELClientCommands.removePole(o:getSquare());
		end
	end
end

function ELClientCommands.removePole(square)
	for i,v in ipairs(ELClientCommands.Lightpoles) do
		if v.x == square:getX() and v.y == square:getY() and v.z == square:getZ() then
			table.remove(ELClientCommands.Lightpoles, i)
			break;
		end
	end
end

function ELClientCommands.addPole(square)
	local Lightpole = {};
	Lightpole.x = square:getX();
	Lightpole.y = square:getY();
	Lightpole.z = square:getZ();
	table.insert(ELClientCommands.Lightpoles, Lightpole);
end

ELClientCommands.OnClientCommand = function(module, command, player, args)
	if ELCommands[module] and ELCommands[module][command] then
		local argStr = ''
		for k,v in pairs(args) do argStr = argStr..' '..k..'='..tostring(v) end
		noise('received '..module..' '..command..' '..tostring(player)..argStr)
		ELCommands[module][command](player, args)
	end
end

function ELClientCommands.findObject(square)
	if not square then return nil end
	for i=0,square:getSpecialObjects():size()-1 do
		local o = square:getSpecialObjects():get(i)
		if o and instanceof(o, 'IsoThumpable') then
			if not o:haveFuel() then
				if o:getName() == "Lamp on Pillar" or o:getName() == "Electronic Lamp Pillar" or o:getName() == "Light Pole" then
					return o;
				end
			end
		end
	end
	return nil
end

function ELClientCommands.checkPower()
	if isClient() then return; end
	local temptable = ELClientCommands.Lightpoles;
	for i,v in ipairs(temptable) do
		local square = getCell():getOrCreateGridSquare(v.x, v.y, v.z);
		if not (square:haveElectricity() or (SandboxVars.ElecShutModifier > -1 and GameTime:getInstance():getNightsSurvived() < SandboxVars.ElecShutModifier) ) then
			local obj = ELClientCommands.findObject(square);
			if obj then
				obj:toggleLightSource(false)
				obj:sendObjectChange('lightSource')
				ELClientCommands.removePole(square)
			else
				ELClientCommands.removePole(square)
			end
		end
	end
end

ELClientCommands.OnObjectAdded = function(o)
	if isClient() then return end
	
	if o and instanceof(o, 'IsoThumpable') then
		if not o:haveFuel() then
			if o:getName() == "Lamp on Pillar" or o:getName() == "Electronic Lamp Pillar" or o:getName() == "Light Pole" then
				if o:isLightSourceOn() then
					ELClientCommands.addPole(o:getSquare());
				end
			end
		end
	end
end

function ELClientCommands.OnDestroyIsoThumpable(o, player)
	if isClient() then return end
	if not o:getSquare() or not (o:getName() == "Lamp on Pillar" or o:getName() == "Electronic Lamp Pillar") or o:getName() == "Light Pole" then
		return
	end
	local sq = o:getSquare()
	ELClientCommands.removePole(sq);
end

Events.EveryTenMinutes.Add(ELClientCommands.checkPower);

Events.OnObjectAdded.Add(ELClientCommands.OnObjectAdded)
Events.OnDestroyIsoThumpable.Add(ELClientCommands.OnDestroyIsoThumpable);

Events.OnClientCommand.Add(ELClientCommands.OnClientCommand)